var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _a, _rootRef, _wrapperRef, _placeholderRef, _inputRef, _stubRef, _onChange, _onInput, _handleInput, handleInput_fn, _initializeDom, initializeDom_fn, _fitSize, fitSize_fn;
import React from "react";
const styles = {};
const rootCommon = {
  display: "inline-block",
  boxSizing: "border-box",
  maxWidth: "100%",
  minWidth: "100px",
  overflow: "hidden",
  verticalAlign: "bottom",
  padding: 2
};
const rootStyled = {
  border: "1px solid #ccc",
  backgroundColor: "white"
};
styles.root = {
  ...rootCommon,
  overflow: "hidden"
};
styles.rootStyled = {
  ...styles.root,
  ...rootStyled
};
styles.rootMl = {
  ...rootCommon,
  overflow: "auto"
};
styles.rootMlStyled = {
  ...styles.rootMl,
  ...rootStyled
};
styles.textareaWrap = {
  display: "block",
  position: "relative",
  width: "100%"
};
styles.inputWrap = {
  display: "inline-block",
  overflowX: "scroll",
  overflowY: "hidden",
  position: "relative",
  width: "100%"
};
const inputCommon = {
  fontSize: "14px",
  fontFamily: "sans-serif",
  boxSizing: "border-box",
  borderWidth: "0",
  minWidth: "100%",
  margin: "0",
  padding: "0",
  lineHeight: "20px",
  whiteSpace: "pre"
};
styles.input = {
  ...inputCommon,
  position: "relative",
  zIndex: 1,
  verticalAlign: "text-bottom",
  outline: "none",
  caretColor: "black",
  backgroundColor: "transparent",
  color: "rgba(0,0,0,0)",
  resize: "none",
  overflow: "hidden"
};
styles.stub = {
  display: "block",
  position: "fixed",
  left: "-100000px",
  opacity: 0,
  whiteSpace: "pre"
};
styles.placeholder = {
  ...inputCommon,
  position: "absolute",
  zIndex: 0,
  top: 0,
  left: 0,
  display: "block",
  overflow: "hidden",
  whiteSpace: "pre"
};
const scrollbar = getScrollbarSize();
class InputData {
  constructor(inputType, data, selectionStart, selectionEnd = selectionStart) {
    this.inputType = inputType;
    this.data = data;
    this.selectionStart = selectionStart;
    this.selectionEnd = selectionEnd;
  }
}
export default class MightyInput extends React.Component {
  constructor() {
    super(...arguments);
    __privateAdd(this, _handleInput);
    __privateAdd(this, _initializeDom);
    __privateAdd(this, _fitSize);
    __publicField(this, "state", {
      value: (_a = this.props.value) != null ? _a : "",
      input: new InputData()
    });
    __privateAdd(this, _rootRef, React.createRef());
    __privateAdd(this, _wrapperRef, React.createRef());
    __privateAdd(this, _placeholderRef, React.createRef());
    __privateAdd(this, _inputRef, React.createRef());
    __privateAdd(this, _stubRef, React.createRef());
    __privateAdd(this, _onChange, (e) => {
      var _a2, _b;
      (_b = (_a2 = this.props).onChange) == null ? void 0 : _b.call(_a2, e);
    });
    __privateAdd(this, _onInput, (e) => {
      var _a2, _b;
      __privateMethod(this, _handleInput, handleInput_fn).call(this, e);
      (_b = (_a2 = this.props).onInput) == null ? void 0 : _b.call(_a2, e);
    });
  }
  get rootEl() {
    return __privateGet(this, _rootRef).current;
  }
  get wrapperEl() {
    return __privateGet(this, _wrapperRef).current;
  }
  get inputEl() {
    return __privateGet(this, _inputRef).current;
  }
  get placeholderEl() {
    return __privateGet(this, _placeholderRef).current;
  }
  get stubEl() {
    return __privateGet(this, _stubRef).current;
  }
  componentDidMount() {
    this.inputEl.addEventListener("beforeinput", (e) => {
      this.setState({
        input: new InputData(e.inputType, e.data, e.target.selectionStart, e.target.selectionEnd)
      });
    });
    __privateMethod(this, _initializeDom, initializeDom_fn).call(this);
    __privateMethod(this, _fitSize, fitSize_fn).call(this, this.state.value);
  }
  fitSize() {
    __privateMethod(this, _fitSize, fitSize_fn).call(this, this.state.value);
  }
  render() {
    var _a2;
    const {
      render,
      filter,
      className,
      onUpdate,
      style,
      modifiers,
      isMultiline,
      rows,
      offsetRight,
      ...props
    } = this.props;
    const { value } = this.state;
    let rootStyle;
    if (className) {
      rootStyle = isMultiline ? styles.rootMl : styles.root;
    } else {
      rootStyle = isMultiline ? styles.rootMlStyled : styles.rootStyled;
    }
    let renderedValue = (_a2 = render(value)) != null ? _a2 : "";
    if (!renderedValue.length) {
      renderedValue = "\xA0";
    }
    let InputComponent = "input";
    if (isMultiline) {
      InputComponent = "textarea";
    }
    return /* @__PURE__ */ React.createElement("div", {
      ref: __privateGet(this, _rootRef),
      className: className != null ? className : "",
      style: rootStyle
    }, /* @__PURE__ */ React.createElement("div", {
      ref: __privateGet(this, _wrapperRef),
      style: isMultiline ? styles.textareaWrap : styles.inputWrap
    }, /* @__PURE__ */ React.createElement(InputComponent, {
      ...props,
      style: styles.input,
      ref: __privateGet(this, _inputRef),
      onChange: __privateGet(this, _onChange),
      onInput: __privateGet(this, _onInput),
      value
    }), /* @__PURE__ */ React.createElement("div", {
      "aria-hidden": true,
      style: styles.placeholder,
      ref: __privateGet(this, _placeholderRef)
    }, renderedValue), /* @__PURE__ */ React.createElement("div", {
      "aria-hidden": true,
      ref: __privateGet(this, _stubRef),
      style: styles.stub
    })));
  }
}
_rootRef = new WeakMap();
_wrapperRef = new WeakMap();
_placeholderRef = new WeakMap();
_inputRef = new WeakMap();
_stubRef = new WeakMap();
_onChange = new WeakMap();
_onInput = new WeakMap();
_handleInput = new WeakSet();
handleInput_fn = function(e) {
  const { value, input } = this.state;
  const { filter } = this.props;
  const newValue = filter(e.target.value, value, input);
  if (value !== newValue) {
    this.setState({
      value: newValue,
      input: new InputData()
    });
    __privateMethod(this, _fitSize, fitSize_fn).call(this, newValue);
    this.props.onUpdate(newValue, value, input);
  }
};
_initializeDom = new WeakSet();
initializeDom_fn = function() {
  const { stubEl, rootEl, inputEl, wrapperEl, props } = this;
  const inputStyle = window.getComputedStyle(inputEl);
  const rootStyle = window.getComputedStyle(rootEl);
  stubEl.style.padding = inputStyle.padding;
  stubEl.style.border = inputStyle.border;
  stubEl.style.fontFamily = inputStyle.fontFamily;
  stubEl.style.fontSize = inputStyle.fontSize;
  stubEl.style.lineHeight = inputStyle.lineHeight;
  stubEl.textContent = "\xA0\n".repeat(props.rows);
  rootEl.style.height = parseInt(rootStyle.paddingTop, 10) + parseInt(rootStyle.paddingBottom, 10) + parseInt(rootStyle.borderTopWidth || 0, 10) + parseInt(rootStyle.borderBottomWidth || 0, 10) + stubEl.offsetHeight + "px";
  wrapperEl.style.height = rootEl.offsetHeight + (!props.isMultiline ? scrollbar.height || 20 : 0) + "px";
};
_fitSize = new WeakSet();
fitSize_fn = function(value) {
  const {
    stubEl,
    placeholderEl,
    inputEl,
    wrapperEl,
    props
  } = this;
  let linesCount = countLines(value, props.rows);
  let tail = "\n".repeat(Math.max(0, props.rows - linesCount));
  stubEl.textContent = value + tail + "\xA0";
  const { offsetWidth, offsetHeight } = stubEl;
  placeholderEl.style.width = inputEl.style.width = offsetWidth + props.offsetRight + "px";
  placeholderEl.style.height = inputEl.style.height = offsetHeight + "px";
  if (props.isMultiline) {
    wrapperEl.style.height = offsetHeight + "px";
  }
};
__publicField(MightyInput, "defaultProps", {
  filter: (v) => v,
  render: (v) => v,
  onChange: () => {
  },
  onUpdate: () => {
  },
  isMultiline: false,
  rows: 1,
  offsetRight: 0
});
function getScrollbarSize() {
  const root = document.createElement("div");
  root.style.position = "absolute";
  root.style.top = "-100px";
  const outer = document.createElement("div");
  outer.style.position = "relative";
  outer.style.width = "100px";
  outer.style.height = "100px";
  outer.style.overflow = "scroll";
  const inner = document.createElement("div");
  inner.style.position = "absolute";
  inner.style.top = "0px";
  inner.style.bottom = "0px";
  inner.style.right = "0px";
  inner.style.left = "0px";
  outer.appendChild(inner);
  root.appendChild(outer);
  document.body.appendChild(root);
  const width = outer.offsetWidth - inner.offsetWidth;
  const height = outer.offsetHeight - inner.offsetHeight;
  document.body.removeChild(root);
  return { width, height };
}
function countLines(string, threshold = Infinity) {
  let count = 1;
  let lastIndex = -1;
  while (true) {
    if (count >= threshold) {
      return count;
    }
    let i = string.indexOf("\n", lastIndex);
    if (i > -1) {
      count += 1;
      lastIndex = i + 1;
    } else {
      break;
    }
  }
  return count;
}
//# sourceMappingURL=mighty-input.js.map
